@import "mixins";

.my-markdown-body {
  // Typography

  p {
    @apply mb-4;
  }

  h1,
  h2,
  h3,
  h4,
  h5,
  h6 {
    @apply mt-0 mb-2 font-semibold leading-5;
  }

  h1 {
    @apply text-4xl;
  }

  h2 {
    @apply text-3xl;
  }

  h3 {
    @apply text-2xl;
  }

  h4 {
    @apply text-xl;
  }

  h5 {
    @apply text-lg;
  }

  h6 {
    @apply text-base;
  }

  h1,
  h2 {
    @apply mt-6 mb-6;
  }

  pre {
    @apply p-4 mb-4 overflow-auto text-sm leading-6 bg-gray-100 dark:bg-gray-800 rounded-md;
    // padding: 16px;
    // overflow: auto;
    // font-size: 85%;
    // line-height: 1.45;
    // background-color: #f6f8fa;
    // border-radius: 3px;
  }

  blockquote {
    @apply p-4 mb-4 overflow-auto bg-gray-100 dark:bg-gray-800 rounded-md;

    & > *:last-child {
      @apply mb-0;
    }
  }

  code {
    @apply px-2 text-sm bg-gray-100 dark:bg-gray-800 rounded-md;
    padding-top: 0.2rem;
    padding-bottom: 0.2rem;
    // padding: .2em .4em;
    // margin: 0;
    // font-size: 85%;
    // background-color: rgba(27,31,35,.05);
    // border-radius: 3px;
  }

  // Misc

  hr {
    @apply -ml-16 my-8;
    @include border-themed;
  }

  // Lists

  ol,
  ul {
    @apply pl-8 mb-4;

    ol,
    ul {
      @apply mb-0;
    }
  }

  ol {
    @apply list-decimal;
  }

  ul {
    @apply list-disc;

    ul {
      @apply list-circle;

      ul {
        @apply list-square;
      }
    }
  }

  // Collapsible

  details {
    @apply border rounded-lg py-3 px-6;
    @include border-themed;

    summary {
      @apply -my-3 -mx-6 py-3 px-6 cursor-pointer;
    }

    &[open] summary {
      @apply border-b mb-3;
      @include border-themed;
    }
  }

  // Tables

  table {
    @apply border-separate rounded-lg hover:shadow-lg transition-shadow overflow-hidden mb-4;
    border-spacing: 0px;

    tr {
      @apply transition-shadow;

      &:hover {
        box-shadow: 0 0 15px -3px rgba(0, 0, 0, 0.1),
          0 4px 6px -2px rgba(0, 0, 0, 0.05);
      }
    }

    > *:first-child > tr:first-child > *:first-child {
      @apply rounded-tl-lg;
    }

    > *:first-child > tr:first-child > *:last-child {
      @apply rounded-tr-lg;
    }

    > *:last-child > tr:last-child > *:first-child {
      @apply rounded-bl-lg;
    }

    > *:last-child > tr:last-child > *:last-child {
      @apply rounded-br-lg;
    }

    tr th:last-child,
    tr td:last-child {
      @apply border-r pr-8;
    }

    tr th:first-child,
    tr td:first-child {
      @apply border-l pl-8;
    }

    tr th,
    tr td {
      @apply border-t px-4 py-3 text-left border-themed;
    }

    tr:last-child td {
      @apply border-b;
    }
  }

  // Mermaid

  .mermaid {
    .node rect,
    .node circle,
    .node ellipse,
    .node polygon,
    .node path {
      fill: var(--color-primary-50) !important;
      stroke: var(--color-primary-500) !important;

      @include dark {
        fill: transparent !important;
      }
    }

    .label text,
    span {
      color: var(--color-gray-900) !important;

      @include dark {
        color: var(--color-gray-50) !important;
      }
    }

    .flowchart-link,
    #flowchart-pointStart,
    #flowchart-pointEnd {
      fill: var(--color-gray-700);
      stroke: var(--color-gray-700) !important;

      @include dark {
        fill: var(--color-gray-50);
        stroke: var(--color-gray-50) !important;
      }
    }

    svg > g > .root > .nodes > .root > .clusters > .cluster > rect {
      fill: transparent !important;
    }

    .cluster rect {
      fill: var(--color-secondary-50) !important;
      stroke: var(--color-secondary-500) !important;

      @include dark {
        fill: transparent !important;
      }
    }
  }
}
